from PASTEC.utils.AbstractAdaptatorAgent import AbstractAdaptatorAgent

class HG_BLRnAdaptatorAgent(AbstractAdaptatorAgent):

    CI_MAX = 1
    MIN_IDENTITY = 90
    MIN_COVERAGE = 95
    INIT_CLASSIF = "!PotentialHostGene"
    KEY_FOR_DICT_OF_EVIDENCE = "HG"
    
    def __init__(self, env):
        AbstractAdaptatorAgent.__init__(self, env)
        self._listOfKnownAgents = ["HG_BLRn_Agent"]
    
    def getAgentName(self):
        return "PotentialHostGene"
    
    ## Set conclusionsMatch
    #  
    def setConclusionsMatch(self, conclusionsMatch):
        self._conclusionsMatch = conclusionsMatch
        
    def getConclusionsMatch(self):
        return self._conclusionsMatch
        
    ## Give the classification and the confidence index from all analysis conclusions
    #
    # @return classification, normalized confidence index
    #
    def decide(self):
        classification = self.INIT_CLASSIF
        self._CI = 0
        for conclusion in self._conclusionsMatch:
            classification = self.considerHG_BLRnEvidence(conclusion, classification)
        normalizedIC = self._normalizeIC()
        return classification, normalizedIC
    
    def considerHG_BLRnEvidence(self, conclusion, classification):
        if ((conclusion.getCoverage() > self.MIN_COVERAGE) and (conclusion.getIdentity() > self.MIN_IDENTITY)):
            classification = self.getAgentName()
            self._CI += 1
        return classification
        
    def _fillDictOfEvidence(self):
        dictOfEvidence = {}
        for conclusion in self._conclusionsMatch:
            dictOfEvidence[self.KEY_FOR_DICT_OF_EVIDENCE] = conclusion
        return dictOfEvidence
        
    def makeAppropriateConclusionsForHG_BLRn_Agent(self, iDemendAndResult):
        if iDemendAndResult != None and iDemendAndResult.result != None:
            self._conclusionsMatch.append(iDemendAndResult.result)
                
    def _initializeConclusions(self):
        self._conclusionsMatch = []