from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent

class Maverick_Agent(AbstractClassifierAgent):

    CI_MAX = 16
    INIT_CLASSIF = "!Maverick"
    SINGLE_CONDITIONS = ('C-INT', 'ATP', 'CYP', 'POLB')
    COMPLEXE_CONDITIONS = [('termTIR', '>10000bps')]
    PATTERN_2_SEARCH_IN_BLAST_RESULTS = ":Polinton|:Maverick:"
    PROFILES_2_SEARCH_IN_ORF = ('INT', 'C-INT', 'ATP', 'CYP', 'POLB')
    INCREASED_CI_CONDITIONS = ['>10000bps']
    CATEGORY_LENGTH_BOUND = [10000]

    def getAgentName(self):
        return "Maverick"
    
    def makeAppropriateConclusionsForTRSearch_Agent(self, iDemandAndResult):
        if iDemandAndResult != None:
            for iResult in iDemandAndResult.result:
                if "termTIR" == iResult.getType():
                    self._conclusionsSearch.append(iResult)