class ProfilesCluster(object):
    
    def __init__(self, start, end):
        self._start = start
        self._end = end
        self._profiles = []
    
    def addProfile(self, profile):
        self._start = min(self._start,profile['start'])
        self._end = max(self._end, profile['end'])
        self._profiles.append(profile)
        self._profiles = sorted(self._profiles, key=lambda k: k['start'])

    def _overlapCalculationForProfilesClusterAndProfile(self, dProfile):
        return max(0, min(self._end, dProfile['end']) - max(self._start, dProfile['start']) + 1)
    
    def isProfileInCluster(self, profile):
        overlap = self._overlapCalculationForProfilesClusterAndProfile(profile)
        return overlap != 0
        
    def __eq__(self, o):
        if self._start != o._start or self._end != o._end:
            return False
        else:
            return self._profiles == o._profiles 
        
    def show(self):
        print "cluster " + str(self._start) + " " + str(self._end)
        for profile in self._profiles:
            print profile